Attribute VB_Name = "modUtilita"
'================================================================
' Descrizione.....: Collezione di routines e costanti di utilita'
'                   per le routines DELLIV.
' Nome dei Files..: modUtilita.bas
' Data............: 21/9/2001
' Versione........: 1.0 a 32 bits.
' Sistema.........: VB6 (SP5) sotto Windows NT (SP6).
' Scritto da......: F. Languasco 
' E-Mail..........: MC7061@mclink.it
' DownLoads a.....: http://www.flanguasco.org
'                   http://members.xoom.virgilio.it/flanguasco
'================================================================
'
Option Explicit
'
Public Const PI# = 3.14159265358979    ' 4# * Atn(1#)
Public Const PI2# = 2# * PI
Public Const PI_2# = PI / 2#           ' 90 in [Rad].
Public Const Log10# = 2.30258509299405
'
'--- GetLocale: ----------------------------------------------------------------
Private Declare Function GetLocaleInfo Lib "kernel32" Alias "GetLocaleInfoA" _
    (ByVal Locale As Long, ByVal LCType As Long, ByVal lpLCData As String, _
    ByVal cchData As Long) As Long
Private Declare Function GetThreadLocale Lib "kernel32" () As Long
'
Private Const LOCALE_SDECIMAL& = &HE
Private Const LOCALE_STHOUSAND& = &HF
Private Const LOCALE_SDATE& = &H1D
Private Const LOCALE_STIME& = &H1E
'
'--- CloseButtonDisable: -----------------------------------------------------
Private Declare Function RemoveMenu Lib "user32" (ByVal hMenu As Long, _
    ByVal nPosition As Long, ByVal wFlags As Long) As Long
Private Declare Function GetSystemMenu Lib "user32" (ByVal hWnd As Long, _
    ByVal bRevert As Long) As Long
Private Declare Function DrawMenuBar Lib "user32" (ByVal hWnd As Long) As Long
'
Private Const MF_REMOVE = &H1000&
Private Const MF_ENABLED = &H0&
Private Const MF_INSERT = &H0&
'
Private Const SC_CLOSE = &HF060&
Private Const SC_MINIMIZE = &HF020&
Private Const SC_MAXIMIZE = &HF030&
Private Const SC_RESTORE = &HF120&
'
'--- FillToBorder: -----------------------------------------------------------
Private Const FLOODFILLBORDER = 0
Private Const FLOODFILLSURFACE = 1
'
Private Declare Function ExtFloodFill Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, _
    ByVal Y As Long, ByVal crColor As Long, ByVal wFillType As Long) As Long
Private Declare Function DeleteObject& Lib "gdi32" (ByVal hObject As Long)
Private Declare Function SelectObject& Lib "gdi32" (ByVal hDC As Long, _
    ByVal hObject As Long)
Private Declare Function CreateSolidBrush& Lib "gdi32" (ByVal crColor As Long)
'
'--- PolygonFill: ------------------------------------------------------------
Private Const PS_SOLID = 0
Private Const PS_DASH = 1                    '  -------
Private Const PS_DOT = 2                     '  .......
Private Const PS_DASHDOT = 3                 '  _._._._
Private Const PS_DASHDOTDOT = 4              '  _.._.._
Private Const PS_NULL = 5
Private Const PS_INSIDEFRAME = 6
'
Private Type POINTAPI
     X As Long          ' [Pixels].
     Y As Long          '     "
End Type
'
Private Declare Function Polygon Lib "gdi32" (ByVal hDC As Long, _
    lpPoint As POINTAPI, ByVal nCount As Long) As Long
'
Private Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Long, _
    ByVal nWidth As Long, ByVal crColor As Long) As Long

Public Function PolygonFill(ByVal picPB As PictureBox, XV#(), YV#(), _
    ByVal FillColor&) As Long
'
'   Disegna un poligono con NV vertici definiti in xV(1 to NV), yV(1 to NV)
'   e lo colora con il colore FillColor.
'   picPB.ScaleMode deve essere vbUser.
'   Rev. 18/07/2004
'
    Dim I&, NV&, hPen&, hPen_O&, hBrush&, hBrush_O&
'
    hPen = CreatePen(vbSolid, PS_SOLID, FillColor)
    hPen_O = SelectObject(picPB.hDC, hPen)
    hBrush = CreateSolidBrush(FillColor)
    hBrush_O = SelectObject(picPB.hDC, hBrush)
'
    NV = UBound(XV)
    ' Trovo le coordinate logiche dei vertici xV(), yV():
    ReDim Vert(1 To NV) As POINTAPI
    For I = 1 To NV
        Vert(I).X = CLng(picPB.ScaleX(XV(I) - picPB.ScaleLeft, vbUser, vbPixels))
        Vert(I).Y = CLng(picPB.ScaleY(YV(I) - picPB.ScaleTop, vbUser, vbPixels))
    Next I
'
    Polygon picPB.hDC, Vert(1), NV
'
    SelectObject picPB.hDC, hPen_O
    SelectObject picPB.hDC, hBrush_O
    DeleteObject hPen
    DeleteObject hBrush
'
'
'
End Function
Public Function FillToBorder(ByVal picPB As PictureBox, ByVal xCg#, ByVal yCg#, _
    ByVal FillColor&, Optional ByVal BorderColor& = vbBlack) As Long
'
'   Colora l' area di picPB, intorno al punto xCg, yCg con il colore FillColor.
'   L' area colorata e' delimitata dal colore specificato nel parametro BorderColor.
'   picPB.ScaleMode deve essere vbUser.
'   Rev. 15/07/2004
'
    Dim X0&, Y0&, hBrush&, hBrush_O&
'
    hBrush = CreateSolidBrush(FillColor)
    hBrush_O = SelectObject(picPB.hDC, hBrush)
'
    ' Trovo le coordinate logiche di xCg, yCg:
    X0 = CLng(picPB.ScaleX(xCg - picPB.ScaleLeft, vbUser, vbPixels))
    Y0 = CLng(picPB.ScaleY(yCg - picPB.ScaleTop, vbUser, vbPixels))
'
    FillToBorder = ExtFloodFill(picPB.hDC, X0, Y0, BorderColor, FLOODFILLBORDER)
'
    SelectObject picPB.hDC, hBrush_O
    DeleteObject hBrush
'
'
'
End Function
Public Function SIGN(ByVal dV#, ByVal dS#) As Double
'
'   Ritorna il valore assoluto di dV con il segno di dS.
'   Implementa la funzione SIGN del FORTRAN:
'
    If dS < 0 Then
        SIGN = -Abs(dV)
    Else
        SIGN = Abs(dV)
    End If
'
'
'
End Function
Public Sub CloseButtonDisable(ByVal frmForm As Form)
'
'
    Dim R1&
'
    R1 = RemoveMenu(GetSystemMenu(frmForm.hWnd, 0), SC_CLOSE, MF_REMOVE)
'
'
'
End Sub
Public Sub AggiornaFilesRecenti(ByVal mnuRecenti As Object, ByVal FileRec$ _
    , Optional ByVal MAXFIL& = 5)
'
'   Aggiunge al menu mnuRecenti() il file FileRec$.
'   mnuRecenti e' una voce di menu, con indice:
'   mnuRecenti(0) e' il titolo, i files da memorizzare
'   iniziano dalla posizione mnuRecenti(1).
'   Se FileRec$ e' gia' presente lo sposta al primo posto.
'   MAXFIL e' il numero massimo di files recenti da ricordare:
'   puo' essere diverso a seconda dell' applicazione che usa
'   questa routine (0 < MAXFIL < 10).
'
    Dim I&, F&, FILN&
    Dim a$, NuovoFile As Boolean
'
    If FileRec$ = "" Then Exit Sub
'
    FILN = mnuRecenti.UBound
'
    NuovoFile = True
    For F = 1 To FILN
        a$ = mnuRecenti(F).Caption
        If UCase$(Right$(a$, Len(a$) - 3)) = UCase$(FileRec$) Then
            NuovoFile = False
            Exit For
        End If
    Next F
    If F > FILN Then F = FILN
'
    If (FILN < MAXFIL) And NuovoFile Then
        FILN = FILN + 1
        F = FILN
        Load mnuRecenti(FILN)
        mnuRecenti(FILN).Visible = True
    End If
'
    mnuRecenti(0).Visible = (FILN > 0)
'
    For I = F To 2 Step -1
        a$ = mnuRecenti(I - 1).Caption
        a$ = "&" & Trim$(Str$(I)) & " " & Right$(a$, Len(a$) - 3)
        mnuRecenti(I).Caption = a$
    Next I
'
    mnuRecenti(1).Caption = "&1 " & FileRec$
'
'
'
End Sub
Public Sub LeggiFilesRecenti(ByVal mnuRecenti As Object, ByVal Sezione$ _
    , Optional ByVal MAXFIL& = 5, Optional ByVal VerificaFE As Boolean = True)
'
'   Legge dal Registry di Windows e se e' definito il "Product Name"
'   del progetto, i files recenti e li aggiunge al menu mnuRecenti().
'   Se VerificaFE = True verifica anche l' esistenza dei files da
'   aggiungere:
'
    Dim I&, FileRec$
'
    If App.ProductName = "" Then Exit Sub
'
    For I = MAXFIL To 1 Step -1
        FileRec$ = GetSetting(App.ProductName, Sezione$, Str$(I), "")
        If FileRec$ <> "" Then
            If VerificaFE Then
                If FileExists(FileRec$) Then _
                    AggiornaFilesRecenti mnuRecenti, FileRec$, MAXFIL
            Else
                AggiornaFilesRecenti mnuRecenti, FileRec$, MAXFIL
            End If
        End If
    Next I
'
'
'
End Sub
Public Sub SalvaFilesRecenti(ByVal mnuRecenti As Object, ByVal Sezione$)
'
'   Salva nel Registry di Windows e se e' definito il "Product Name"
'   del progetto, i files recenti contenuti nel menu mnuRecenti():
'
    Dim I&, FileRec$
'
    If App.ProductName = "" Then Exit Sub
'
    For I = 1 To mnuRecenti.UBound
        FileRec$ = mnuRecenti(I).Caption
        FileRec$ = Right$(FileRec$, Len(FileRec$) - 3)
        SaveSetting App.ProductName, Sezione$, Str$(I), FileRec$
    Next I
'
'
'
End Sub
Public Sub SalvaPosizioneForm(ByVal frmF As Form _
    , Optional ByVal Dimensioni As Boolean = False)
'
'   Salva, sul Registry di Window e se e' definito il
'   "Product Name" del progetto, la posizione finale
'   del Form frmF.  Da usare nell' evento frmF_Unload.
'   Se Dimensioni = True salva anche le dimensioni:
'
    If (frmF.WindowState <> vbMinimized) And (App.ProductName <> "") Then
        SaveSetting App.ProductName, "PosizioniForms", frmF.Name & "_Left", frmF.Left
        SaveSetting App.ProductName, "PosizioniForms", frmF.Name & "_Top", frmF.Top
'
        If Dimensioni Then
            SaveSetting App.ProductName, "PosizioniForms", frmF.Name & "_Width", frmF.Width
            SaveSetting App.ProductName, "PosizioniForms", frmF.Name & "_Height", frmF.Height
        End If
    End If
'
'
'
End Sub
Public Sub LeggiPosizioneForm(ByVal frmF As Form, ByRef frmF_Left&, ByRef frmF_Top& _
    , Optional ByRef frmF_Width&, Optional ByRef frmF_Height&)
'
'   Legge, se e' definito il "Product Name" del progetto, la posizione
'   iniziale e le dimensioni  del Form frmF memorizzate sul Registry di Window.
'   Da usare nell' evento frmF_Load:
'
    If App.ProductName <> "" Then
        frmF_Left = Val(GetSetting(App.ProductName, "PosizioniForms", _
                    frmF.Name & "_Left", RandU(5, 4500)))
        frmF_Top = Val(GetSetting(App.ProductName, "PosizioniForms", _
                   frmF.Name & "_Top", RandU(5, 4500)))
'
        frmF_Width = Val(GetSetting(App.ProductName, "PosizioniForms", _
                     frmF.Name & "_Width", frmF.Width))
        frmF_Height = Val(GetSetting(App.ProductName, "PosizioniForms", _
                      frmF.Name & "_Height", frmF.Height))
    Else
        frmF_Left = RandU(5, 4500)
        frmF_Top = RandU(5, 4500)
'
        frmF_Width = frmF.Width
        frmF_Height = frmF.Height
    End If
'
    If frmF_Width > Screen.Width - 4 Then frmF_Width = Screen.Width - 4
    If frmF_Height > Screen.Height - 4 Then frmF_Height = Screen.Height - 4
'
'
'
End Sub
Public Function DATAN2(ByVal Y#, ByVal X#) As Double
'
'   Ritorna il Valore dell' ArcoTangente di y/x
'   come implementata dal FORTRAN.
'   E':    -PI < DATAN2 <= PI.
'
    Select Case X
    Case Is > 0#
        DATAN2 = Atn(Y / X)
'
    Case Is < 0#
        If Y >= 0# Then
            DATAN2 = Atn(Y / X) + PI
        ElseIf Y < 0# Then
            DATAN2 = Atn(Y / X) - PI
        End If
'
    Case Is = 0#
        DATAN2 = Sgn(Y) * PI / 2#
    End Select
'
'
'
End Function
Public Function KAscNumInteri(ByVal KA%, _
    Optional ByVal NEG As Boolean = False) As Integer
'
'   Ritorna solo i caratteri validi per un campo
'   contenente un numero intero (anche negativo se
'   viene passato il valore Neg = True).
'   Tutti gli altri caratteri vengono annullati.
'   Va' usato nella procedura KeyPress di TextB come:
'   KeyAscii = KAscNumInteri(KeyAscii [, Neg])
'
    Dim KeyMinus%
    Dim TextB As TextBox    ' Solo per TextBoxes.
    'Dim TextB As Control    ' Anche per Combo, etc...
'
    Const myKeyMinus% = 45  ' E' il valore effettivamente ritornato
                            ' alla pressione del tasto - ;
                            ' vbKeySubtract (= 109) non funziona.
'
    Set TextB = Screen.ActiveControl
'
    ' Filtro per il segno "-":
    If (Left$(TextB.Text, 1) <> "-" Or TextB.SelText = TextB.Text) _
    And NEG And TextB.SelStart = 0 Then KeyMinus = myKeyMinus
'
    Select Case KA
    Case vbKey0 To vbKey9, KeyMinus, vbKeyBack
        KAscNumInteri = KA
'
    Case Else
        KAscNumInteri = 0
    End Select
'
'
'
End Function
Public Function KAscNumReali(ByVal KA As Integer _
    , Optional ByVal NEG As Boolean = False) As Integer
'
'   Ritorna solo i caratteri validi per un campo
'   contenente un numero reale (anche negativo se
'   viene passato il valore Neg = True).
'   Tutti gli altri caratteri vengono annullati.
'   Usa le impostazioni locali del separatore decimale.
'   Va' usato nella procedura KeyPress di TextB come:
'   KeyAscii = KAscNumReali(KeyAscii [, Neg])
'   Questa versione accetta anche numeri in notazione
'   scientifica.
'
    Dim KeyDecimal%, KeyMinus%, KeyE%
    Dim TextB As TextBox    ' Solo per TextBoxes.
    'Dim TextB As Control    ' Anche per Combo, etc...
    Dim SD$, SM$, myKeyDecimal%
'
    Const myKeyMinus% = 45      ' E' il valore effettivamente ritornato
                                ' alla pressione del -;
                                ' vbKeySubtract (= 109)  non funziona.
    GetLocale SD$, SM$          ' Trova le impostazioni locali dei
    myKeyDecimal% = Asc(SD$)    ' separatori decimale e delle migliaia.
'
    Set TextB = Screen.ActiveControl
'
    ' Filtro per il separatore decimale:
    If (InStr(TextB.Text, SD$) = 0 _
    And Not (TextB.SelStart = 0 And Left$(TextB.Text, 1) = "-")) _
    Or TextB.SelText = TextB.Text Then KeyDecimal = myKeyDecimal
'
    ' Filtro per il segno "-":
    If (Left$(TextB.Text, 1) <> "-" Or TextB.SelText = TextB.Text) _
    And NEG And TextB.SelStart = 0 Then KeyMinus = myKeyMinus
'
    ' Filtro per la notazione scientifica:
    If TextB.SelStart > 0 Then
        KA = Asc(UCase$(Chr$(KA)))
        If (InStr(TextB.Text, "E") = 0 _
        And Not (TextB.SelStart = 0 Or TextB.SelText = TextB.Text)) _
        And Mid$(TextB.Text, TextB.SelStart, 1) <> "-" Then KeyE = vbKeyE
'
        If Mid$(TextB.Text, TextB.SelStart, 1) = "E" Then KeyMinus = myKeyMinus
'
        If (InStr(TextB.Text, "E") > 0) _
        And (TextB.SelStart - InStr(TextB.Text, "E") >= 0) Then KeyDecimal = 0
    End If
'
    Select Case KA
    Case vbKey0 To vbKey9, KeyDecimal, KeyMinus, vbKeyBack, KeyE
        KAscNumReali = KA
'
    Case Else
        KAscNumReali = 0
    End Select
'
'
'
End Function
Private Sub GetLocale(Optional ByRef dS$, Optional ByRef MS$, _
    Optional ByRef GS$, Optional ByRef TS$)
'
'   Trova i separatori del sistema:
'    DS$:   separatore decimale.
'    MS$:   separatore delle migliaia.
'    GS$:   separatore dei giorni.
'    TS$:   separatore delle ore.
'
    dS$ = "  "
    MS$ = "  "
    GS$ = "  "
    TS$ = "  "
'
    GetLocaleInfo GetThreadLocale(), LOCALE_SDECIMAL, dS$, Len(dS$)
    GetLocaleInfo GetThreadLocale(), LOCALE_STHOUSAND, MS$, Len(MS$)
    GetLocaleInfo GetThreadLocale(), LOCALE_SDATE, GS$, Len(GS$)
    GetLocaleInfo GetThreadLocale(), LOCALE_STIME, TS$, Len(TS$)
'
    dS$ = Left$(dS$, 1)
    MS$ = Left$(MS$, 1)
    GS$ = Left$(GS$, 1)
    TS$ = Left$(TS$, 1)
'
'
'
End Sub

Public Function IsLoaded(ByVal frmF As Form) As Boolean
'
'   Ritorna True se il Form frmF e' gia' caricato in memoria:
'
    Dim I&
'
    For I = 0 To Forms.Count - 1
        If Forms(I) Is frmF Then
            IsLoaded = True
            Exit Function
        End If
    Next I
'
    IsLoaded = False
'
'
'
End Function
Public Function TabellaColori(ByVal NCol&) As Long()
'
'   Ritorna un vettore contenente NCol (2, 16, 256, 1280 o 1792) colori
'   in formato RGB.  La scala di colore, per NCOL = 1280, va' dal Viola
'   al Rosso; per NCOL = 1792, va' dal Bianco al Nero:
'
    Dim c&, C1&, C2&
    Dim R&, g&, b&
    ReDim TCol(0 To NCol - 1) As Long ' Tabella dei colori.
'
    Select Case NCol
    Case 2
        ' Prepara la tabella a 2 colori:
        TCol(0) = vbWhite
        TCol(1) = &H808080 ' Grigio.
'
    Case 16
        ' Prepara la tabella a 16 colori:
        For c = 0 To 15
            R = 255 * (Sqr(c) / Sqr(15))
            If c < 8 Then
                g = CLng(255 * (Sqr(c) / Sqr(7)))
            Else
                g = CLng(255 * (Sqr(15 - c) / Sqr(7)))
            End If
            b = 255 * (1! - Sqr(c) / Sqr(15))
'
            TCol(c) = RGB(R, g, b)
            TCol(c) = QBColor(c)
        Next c
'
    Case 256
        ' Prepara la tabella a 256 colori:
        For c = 0 To 255
            R = 255 * (Sqr(c) / Sqr(255))
            If c < 128 Then
                g = CLng(255 * (Sqr(c) / Sqr(127)))
            Else
                g = CLng(255 * (Sqr(255 - c) / Sqr(127)))
            End If
            b = 255 * (1! - Sqr(c) / Sqr(255))
'
            TCol(c) = RGB(R, g, b)
        Next c
        'TCol(0) = 0
'
    Case 1280
        ' Prepara la tabella a 1280 colori:
        c = 0
        For C1 = 0 To 4
            For C2 = 0 To 255
                R = Switch(C1 = 0, 255 - C2 _
                         , C1 = 1, 0 _
                         , C1 = 2, 0 _
                         , C1 = 3, C2 _
                         , C1 = 4, 255)
                g = Switch(C1 = 0, 0 _
                         , C1 = 1, C2 _
                         , C1 = 2, 255 _
                         , C1 = 3, 255 _
                         , C1 = 4, 255 - C2)
                b = Switch(C1 = 0, 255 _
                         , C1 = 1, 255 _
                         , C1 = 2, 255 - C2 _
                         , C1 = 3, 0 _
                         , C1 = 4, 0)
'
                TCol(c) = RGB(R, g, b)
                c = c + 1
            Next C2
        Next C1
'
    Case 1792
        ' Prepara la tabella a 1792 colori:
        For C1 = 0 To 6
            For C2 = 0 To 255
                R = Switch(C1 = 0, 255 _
                         , C1 = 1, 255 - C2 _
                         , C1 = 2, 0 _
                         , C1 = 3, 0 _
                         , C1 = 4, C2 _
                         , C1 = 5, 255 _
                         , C1 = 6, 255 - C2)
                g = Switch(C1 = 0, 255 - C2 _
                         , C1 = 1, 0 _
                         , C1 = 2, C2 _
                         , C1 = 3, 255 _
                         , C1 = 4, 255 _
                         , C1 = 5, 255 - C2 _
                         , C1 = 6, 0)
                b = Switch(C1 = 0, 255 _
                         , C1 = 1, 255 _
                         , C1 = 2, 255 _
                         , C1 = 3, 255 - C2 _
                         , C1 = 4, 0 _
                         , C1 = 5, 0 _
                         , C1 = 6, 0)
'
                TCol(c) = RGB(R, g, b)
                c = c + 1
            Next C2
        Next C1
    End Select
'
    TabellaColori = TCol()
'
'
'
End Function
Public Function RandU(ByVal V_Min!, ByVal V_Max!) As Single
'
'   Ritorna una variabile casuale reale a distribuzione uniforme:
'
    RandU = V_Min + (V_Max - V_Min) * Rnd
'
'
'
End Function
Public Function Decima(dV#(), Optional ByRef lNV&) As Double()
'
'   Ritorna un vettore con gli elementi di dV()
'   ma senza i doppioni.
'   lNV e' il numero degli elementi rimasti:
'
    Dim I&, J&, Il&, Iu&, K&, dVT#()
'
    Il = LBound(dV)
    Iu = UBound(dV)
    I = Il - 1
    dVT() = dV()
'
    Do
        I = I + 1
        J = I + 1
        Do While J <= Iu
            If dVT(I) = dVT(J) Then
                For K = J To Iu - 1
                    dVT(K) = dVT(K + 1)
                Next K
                Iu = Iu - 1
            Else
                J = J + 1
            End If
        Loop
    Loop While I < Iu
'
    lNV = Iu - Il + 1
    ReDim Preserve dVT(Il To Iu)
'
    Decima = dVT()
'
'
'
End Function
Public Sub QuickSort(ByRef ValTab() As Double, ByVal Low&, ByVal High&, _
    Optional ByVal Verso& = -1)
'
'   Routine QuickSort:
'    ValTab():  Vettore che si vuole ordinare.
'    Low:       Posizione iniziale della zona da ordinare.
'    High:      Posizione finale della zona da ordinare.
'    Verso:     Direzione dell' ordinamento:
'                > 0 -> dal minore al maggiore.
'                = 0 -> nessun ordinamento.
'                < 0 -> dal maggiore al minore.
'
    Dim RandIndex&, I&, J&, M$
    Dim ValTemp As Double   ' Tipo del vettore che si vuole ordinare.
    Dim Part As Double      ' Tipo della chiave di ordinamento.
'
    On Error GoTo QuickSort_ERR
    If Verso = 0 Then Exit Sub
'
    If Low < High Then
'
        If High - Low = 1 Then
            ' Only two elements in this subdivision; swap them
            ' if they are out of order, then end recursive calls:
            If ((Verso > 0) And (ValTab(Low) > ValTab(High))) _
            Or ((Verso < 0) And (ValTab(Low) < ValTab(High))) Then
                'SWAP ValTab(Low), ValTab(High)
                ValTemp = ValTab(Low)
                ValTab(Low) = ValTab(High)
                ValTab(High) = ValTemp
            End If
'
        Else
            ' Pick a pivot element, then move it to the end:
            RandIndex = (High + Low) / 2
            'SWAP ValTab(High), ValTab(RandIndex)
            ValTemp = ValTab(High)
            ValTab(High) = ValTab(RandIndex)
            ValTab(RandIndex) = ValTemp
            Part = ValTab(High)
'
            ' Move in from both sides towards the pivot element:
            Do
                I = Low: J = High
                Do While ((Verso > 0) And (I < J) And (ValTab(I) <= Part)) _
                Or ((Verso < 0) And (I < J) And (ValTab(I) >= Part))
                    I = I + 1
                Loop
                Do While ((Verso > 0) And (J > I) And (ValTab(J) >= Part)) _
                Or ((Verso < 0) And (J > I) And (ValTab(J) <= Part))
                    J = J - 1
                Loop
'
                If I < J Then
                    ' We haven't reached the pivot element; it means that two
                    ' elements on either side are out of order, so swap them:
                    'SWAP ValTab(I), ValTab(J)
                    ValTemp = ValTab(I)
                    ValTab(I) = ValTab(J)
                    ValTab(J) = ValTemp
                End If
'
            Loop While I < J
            ' Move the pivot element back to its proper place in the array:
            'SWAP ValTab(I), ValTab(High)
            ValTemp = ValTab(I)
            ValTab(I) = ValTab(High)
            ValTab(High) = ValTemp
'
            ' Recursively call the QuickSort procedure (pass the smaller
            ' subdivision first to use less stack space):
            If (I - Low) < (High - I) Then
                QuickSort ValTab(), Low, I - 1, Verso
                QuickSort ValTab(), I + 1, High, Verso
            Else
                QuickSort ValTab(), I + 1, High, Verso
                QuickSort ValTab(), Low, I - 1, Verso
            End If
        End If
    End If
'
'
QuickSort_ERR:
    If (Err <> 0) Then
        M$ = "Errore " & Str$(Err.Number) & vbNewLine
        M$ = M$ & Err.Description
        MsgBox M$, vbCritical, " QuickSort"
    End If
'
'
'
End Sub
Public Sub QuickSort3V(ByRef ValTab#(), ByRef ValTab1#(), ByRef ValTab2#(), _
    ByVal Low&, ByVal High&, Optional ByVal Verso& = -1)
'
'   Routine QuickSort3V:
'    ValTab():  Vettore che si vuole ordinare.
'    ValTab1(): Primo vettore associato.
'    ValTab2(): Secondo vettore associato.
'    Low:       Posizione iniziale della zona da ordinare.
'    High:      Posizione finale della zona da ordinare.
'    Verso:     Direzione dell' ordinamento:
'                > 0 -> dal minore al maggiore.
'                = 0 -> nessun ordinamento.
'                < 0 -> dal maggiore al minore.
'
    Dim RandIndex&, I&, J&, M$
    Dim ValTemp As Double   ' Tipo del vettore che si vuole ordinare.
    Dim Part As Double      ' Tipo della chiave di ordinamento.
'
    On Error GoTo QuickSort3V_ERR
    If Verso = 0 Then Exit Sub
'
    If Low < High Then
'
        If High - Low = 1 Then
            ' Only two elements in this subdivision; swap them
            ' if they are out of order, then end recursive calls:
            If ((Verso > 0) And (ValTab(Low) > ValTab(High))) _
            Or ((Verso < 0) And (ValTab(Low) < ValTab(High))) Then
                'SWAP ValTab(Low), ValTab(High)
                ' Vettore principale:
                ValTemp = ValTab(Low)
                ValTab(Low) = ValTab(High)
                ValTab(High) = ValTemp
                ' Primo vettore associato:
                ValTemp = ValTab1(Low)
                ValTab1(Low) = ValTab1(High)
                ValTab1(High) = ValTemp
                ' Secondo vettore associato:
                ValTemp = ValTab2(Low)
                ValTab2(Low) = ValTab2(High)
                ValTab2(High) = ValTemp
            End If
'
        Else
            ' Pick a pivot element, then move it to the end:
            RandIndex = (High + Low) / 2
            'SWAP ValTab(High), ValTab(RandIndex)
            ' Vettore principale:
            ValTemp = ValTab(High)
            ValTab(High) = ValTab(RandIndex)
            ValTab(RandIndex) = ValTemp
            Part = ValTab(High)
            ' Primo vettore associato:
            ValTemp = ValTab1(High)
            ValTab1(High) = ValTab1(RandIndex)
            ValTab1(RandIndex) = ValTemp
            ' Secondo vettore associato:
            ValTemp = ValTab2(High)
            ValTab2(High) = ValTab2(RandIndex)
            ValTab2(RandIndex) = ValTemp
'
            ' Move in from both sides towards the pivot element:
            Do
                I = Low: J = High
                Do While ((Verso > 0) And (I < J) And (ValTab(I) <= Part)) _
                Or ((Verso < 0) And (I < J) And (ValTab(I) >= Part))
                    I = I + 1
                Loop
                Do While ((Verso > 0) And (J > I) And (ValTab(J) >= Part)) _
                Or ((Verso < 0) And (J > I) And (ValTab(J) <= Part))
                    J = J - 1
                Loop
'
                If I < J Then
                    ' We haven't reached the pivot element; it means that two
                    ' elements on either side are out of order, so swap them:
                    'SWAP ValTab(I), ValTab(J)
                    ' Vettore principale:
                    ValTemp = ValTab(I)
                    ValTab(I) = ValTab(J)
                    ValTab(J) = ValTemp
                    ' Primo vettore associato:
                    ValTemp = ValTab1(I)
                    ValTab1(I) = ValTab1(J)
                    ValTab1(J) = ValTemp
                    ' Secondo vettore associato:
                    ValTemp = ValTab2(I)
                    ValTab2(I) = ValTab2(J)
                    ValTab2(J) = ValTemp
                End If
'
            Loop While I < J
            ' Move the pivot element back to its proper place in the array:
            'SWAP ValTab(I), ValTab(High)
            ' Vettore principale:
            ValTemp = ValTab(I)
            ValTab(I) = ValTab(High)
            ValTab(High) = ValTemp
            ' Primo vettore associato:
            ValTemp = ValTab1(I)
            ValTab1(I) = ValTab1(High)
            ValTab1(High) = ValTemp
            ' Secondo vettore associato:
            ValTemp = ValTab2(I)
            ValTab2(I) = ValTab2(High)
            ValTab2(High) = ValTemp
'
            ' Recursively call the QuickSort3V procedure (pass the smaller
            ' subdivision first to use less stack space):
            If (I - Low) < (High - I) Then
                QuickSort3V ValTab(), ValTab1(), ValTab2(), Low, I - 1, Verso
                QuickSort3V ValTab(), ValTab1(), ValTab2(), I + 1, High, Verso
            Else
                QuickSort3V ValTab(), ValTab1(), ValTab2(), I + 1, High, Verso
                QuickSort3V ValTab(), ValTab1(), ValTab2(), Low, I - 1, Verso
            End If
        End If
    End If
'
'
QuickSort3V_ERR:
    If (Err <> 0) Then
        M$ = "Errore " & Str$(Err.Number) & vbNewLine
        M$ = M$ & Err.Description
        MsgBox M$, vbCritical, " QuickSort3V"
    End If
'
'
'
End Sub
Public Function CMDialog_Files(ByVal CMDialog As CommonDialog, ByVal Oper$, _
    ByVal Tipo$, ByVal Ext$, Optional ByVal DirNome$ = "", _
    Optional ByVal FileNome$ = "", Optional ByVal Titolo$ = "") As String
'
'   Imposta i valori di una finestra per la gestione dei Files
'   e ritorna il nome completo del File scelto.
'   La gestione degli errori (e.g. cdlCancel) va' fatta nella
'   routine chiamante.
'
'   Parametri:
'    CMDialog:  e' il controllo Common Dialog che si intende usare.
'    Oper$:     operazione da eseguire (solo "Save" o "Open").
'    Tipo$:     tipo dei files da proporre (e.g. "Filtri IIR").
'    Ext$:      estensioni dei files da proporre (e.g. "*.dat[;*.txt]").
'    DirNome$:  Folder di default.
'    FileNome$: nome del File di default.
'    Titolo$:   titolo della finestra.
'
    Dim Filter$
'
    If Oper$ <> "Open" And Oper$ <> "Save" Then Err.Raise 5
'
    ' Prepara ed imposta tipo ed estensioni dei
    ' files da proporre:
    Filter$ = Tipo$ & " (" & Ext$ & ")|" & Ext$ & "|"
    Filter$ = Filter$ & "Tutti i Files (*.*)|*.*"
    CMDialog.Filter = Filter$
    CMDialog.FilterIndex = 1
'
    ' Imposta il Folder di default:
    If DirNome$ <> "" Then
        CMDialog.InitDir = DirNome$
    Else
        CMDialog.InitDir = App.Path
    End If
'
    ' Imposta il File Name di default:
    If FileNome$ <> "" Then
        CMDialog.FileName = FileNome$
    Else
        If Oper$ = "Open" Then
            CMDialog.FileName = ""
        ElseIf Oper$ = "Save" Then
            CMDialog.FileName = Left$(Ext$, 5)
        End If
    End If
'
    ' Scrive il titolo della finestra:
    CMDialog.DialogTitle = " " & Titolo$
'
    ' Controlla l' esistenza del File, chiede conferma
    ' se File Already Exists, nasconde la casella Read Only:
    CMDialog.Flags = cdlOFNFileMustExist + cdlOFNOverwritePrompt _
                   + cdlOFNHideReadOnly
    ' e permette il Cancel:
    CMDialog.CancelError = True
'
    ' Apre la finestra con
    ' l' operazione richiesta:
    If Oper$ = "Open" Then
        CMDialog.ShowOpen
    ElseIf Oper$ = "Save" Then
        CMDialog.ShowSave
    End If
'
    CMDialog_Files = CMDialog.FileName
'
'
'
End Function
Public Function DMIN1(ParamArray Vd() As Variant) As Double
'
'   Implementa la funzione DMIN1(D1, D2, ...DN) del FORTRAN:
'
    Dim J&, J1&, J2&, vDMin As Variant
'
    J1 = LBound(Vd)
    J2 = UBound(Vd)
    vDMin = Vd(J1)
    For J = J1 + 1 To J2
        If vDMin > Vd(J) Then vDMin = Vd(J)
    Next J
'
    DMIN1 = CDbl(vDMin)
'
'
'
End Function
Public Function DMAX1(ParamArray Vd() As Variant) As Double
'
'   Implementa la funzione DMAX1(D1, D2, ...DN) del FORTRAN:
'
    Dim J&, J1&, J2&, vDMax As Variant
'
    J1 = LBound(Vd)
    J2 = UBound(Vd)
    vDMax = Vd(J1)
    For J = J1 + 1 To J2
        If vDMax < Vd(J) Then vDMax = Vd(J)
    Next J
'
    DMAX1 = CDbl(vDMax)
'
'
'
End Function
Public Function Quadro(ByVal Foglio As PictureBox, _
    ByVal X0#, ByVal xn#, ByVal Y0#, ByVal yn#, _
    Optional ByVal FormatVX$ = "#0.0##", _
    Optional ByVal FormatVY$ = "#0.0##", _
    Optional ByVal Npx& = 1, Optional ByRef PxN_X!, Optional ByRef PxN_Y!, _
    Optional ByVal Titolo$ = "", _
    Optional ByVal UnitaX$ = "", _
    Optional ByVal UnitaY$ = "", _
    Optional ByVal AutoRed As Boolean = False, _
    Optional ByRef SxMin!, Optional ByRef SxMax!, _
    Optional ByRef SyMin!, Optional ByRef SyMax!, _
    Optional ByVal RifCol& = vbGreen, _
    Optional ByVal bGriglia As Boolean = True, _
    Optional ByRef tEsec!) As Boolean
'
'   Routine, di uso generale, per la scalatura di un foglio
'   adatto a rappresentare un grafico y = f(x).
'    Parametri in ingresso:
'     Foglio:    PictureBox da scalare.
'     X0:        Valore minimo di ascissa da rappresentare.
'     Xn:        Valore massimo di ascissa da rappresentare.
'                Deve essere X0 <= Xn.
'     Y0:        Valore minimo di ordinata da rappresentare.
'     Yn:        Valore massimo di ordinata da rappresentare.
'                Deve essere Y0 <= Yn.
'     FormatVX$: Stringa di formato dei valori sull' asse X.
'     FormatVY$: Stringa di formato dei valori sull' asse Y.
'     Npx:       N di Pixels di cui si vuole conoscere
'                larghezza ed altezza in [vbUser].
'     Titolo$:   Titolo del grafico.
'     UnitaX$:   Unita' (o titolo) dell' asse X.
'     UnitaY$:   Unita' (o titolo) dell' asse Y.
'     AutoRed:   Stato di Foglio.AutoRedraw dopo il disegno del quadro.
'     RifCol:    Colore degli assi, dei valori e delle griglie di riferimento.
'     bGriglia:  Se True viene disegnata la griglia di riferimento:
'                se False viene fatta solo la scalatura di Foglio.
'    Parametri in uscita:
'     SxMin:     Valore minimo di ascissa rappresentata.
'     SxMax:     Valore massimo di ascissa rappresentata.
'     SyMin:     Valore minimo di ordinata rappresentata.
'     SyMax:     Valore massimo di ordinata rappresentata.
'     PxN_X:     Larghezza in [vbUser] ed
'     PxN_Y:     altezza in [vbUser] di Npx [Pixels].
'     tEsec:     tempo impiegato a disegnare il quadro [s].
'
'   Rev. 25/03/2003
'
    Dim I&, XI!, D_X!, rrx!, YI!, D_Y!, rry!, TxW!, Txt$
    Dim QxMin!, QxMax!, QyMin!, QyMax!
'
    tEsec = Timer
    On Error GoTo Quadro_ERR
'
    ' Verifico la correttezza delle scale:
    If X0 > xn Then Err.Raise 1001, "Quadro", "Errore di scala X."
    If Y0 > yn Then Err.Raise 1001, "Quadro", "Errore di scala Y."
'
'-------------------------------------------------------------------------------------
'   Calcolo del passo di grigliatura degli assi.
'
    Dim DYMin!
    Const ScRis& = 5                ' La risoluzione delle scale e' 10 ^ -ScRis.
    Const ScMin! = 10 ^ (1 - ScRis) ' Ampiezza min. delle scale X e Y.
    Const Log10! = 2.30258509299405 ' Log(10#)
'
    ' Imposto una scala minima
    ' per l' asse X:
    If xn - X0 < ScMin Then
        X0 = X0 - ScMin / 2!
        xn = xn + ScMin / 2!
    End If
'
    ' Calcolo la spaziatura dei valori scritti
    ' sull' asse X: la sequenza e' 1, 2, 2.5 e 5:
    D_X = xn - X0
    rrx = 10! ^ Ceil(Log(D_X / 20!) / Log10)
    Do While D_X / rrx < 5!
        rrx = rrx / 2!
    Loop
    If D_X / rrx > 10! Then rrx = rrx * 2!
    X0 = rrx * Int(Round(X0 / rrx, ScRis))
    xn = rrx * Ceil(Round(xn / rrx, ScRis))
    D_X = xn - X0
    SxMin = X0
    SxMax = xn
'
    ' Imposto una scala minima
    ' per l' asse Y:
    If Format$(Y0, FormatVY$) = Format$(yn, FormatVY$) Then
        DYMin = 0.0001
        Do While Format$(Y0 - DYMin, FormatVY$) = Format$(yn + DYMin, FormatVY$)
            DYMin = 2! * DYMin
        Loop
'
        Y0 = Y0 - 10! * DYMin
        yn = yn + 10! * DYMin
    End If
'
    ' Calcolo la spaziatura dei valori scritti
    ' sull' asse Y: la sequenza e' 1, 2, 2.5 e 5:
    D_Y = yn - Y0
    rry = 10! ^ Ceil(Log(D_Y / 20!) / Log10)
    Do While D_Y / rry < 5!
        rry = rry / 2!
    Loop
    If D_Y / rry > 10! Then rry = rry * 2!
    Y0 = rry * Int(Round(Y0 / rry, ScRis))
    yn = rry * Ceil(Round(yn / rry, ScRis))
    D_Y = yn - Y0
    SyMin = Y0
    SyMax = yn
'
'-------------------------------------------------------------------------------------
'   Calcola larghezza ed altezza dei bordi.
'
    Dim Bl!, Br!, Bb!, Bt!, BDen!
    Dim TxWs!, TxWd!, TxHt!, TxHb!
'
    ' Imposto i dati di Font dei valori
    ' degli assi:
    Foglio.FontName = "MS Sans Serif"
    Foglio.FontSize = 8
    Foglio.FontBold = False
'
    ' Annullo le scale precedenti:
    Foglio.ScaleMode = vbPixels
'
    ' Il bordo a sinistra deve essere sufficiente
    ' a contenere il valore Y piu' largo:
    TxWs = Foglio.TextWidth(Format$(Y0, FormatVY$) & "W")
    If TxWs < Foglio.TextWidth(Format$(yn, FormatVY$) & "W") Then
        TxWs = Foglio.TextWidth(Format$(yn, FormatVY$) & "W")
    End If
'
    ' Il bordo a destra deve essere sufficiente
    ' a contenere il valore Xn e l' etichetta UnitaX$:
    TxWd = (Foglio.TextWidth(Format$(xn, FormatVX$)) / 2!) _
         + Foglio.TextWidth(UnitaX$ & "W")
'
    ' I bordi a sinistra ed a destra sono:
    BDen = D_X / (Foglio.ScaleWidth - TxWs - TxWd)
    Bl = TxWs * BDen
    Br = TxWd * BDen
'
    ' Il bordo sotto e' 2 volte l' altezza dei valori:
    TxHb = 2! * Abs(Foglio.TextHeight("H"))
'
    ' Il bordo sopra e' 2 volte l' altezza dei valori
    ' piu' l' altezza del titolo:
    Foglio.FontSize = 12
    TxHt = TxHb + Abs(Foglio.TextHeight(Titolo$))
'
    ' I bordi sopra e sotto sono:
    BDen = D_Y / (Abs(Foglio.ScaleHeight) + TxHb + TxHt)
    Bb = TxHb * BDen
    Bt = TxHt * BDen
'
'-------------------------------------------------------------------------------------
'   Imposta la scala e calcola i valori comuni.
'
    Dim Po4_X!, Po4_Y!, EstAx!, EstAy!
'
    ' Imposto i bordi orizzontali
    ' e verticali:
    QxMin = X0 - Bl
    QxMax = X0 + D_X + Br
    QyMin = Y0 - Bb
    QyMax = Y0 + D_Y + Bt
'
    ' La scalatura deve essere permanente:
    Foglio.AutoRedraw = True
'
    ' Imposto la scala e cancello il Foglio:
    Foglio.Scale (QxMin, QyMax)-(QxMax, QyMin)
    Foglio.Line (QxMin, QyMin)-(QxMax, QyMax), Foglio.BackColor, BF ' Questo e' piu' veloce
                                                                    ' di Foglio.Cls.
'
    ' Calcolo larghezza ed altezza di Npx pixels:
    PxN_X = Abs(Foglio.ScaleX(Npx, vbPixels, vbUser))
    PxN_Y = Abs(Foglio.ScaleY(Npx, vbPixels, vbUser))
    ' Calcolo larghezza ed altezza di 4 points:
    Po4_X = Foglio.ScaleX(4, vbPoints, vbUser)  ' Uso i [Points] perche' voglio dimensioni
    Po4_Y = Foglio.ScaleY(4, vbPoints, vbUser)  ' proporzionali a quelle dei caratteri.
'
    ' Estremita' degli assi X e Y:
    EstAx = (xn + QxMax) / 2!
    EstAy = (yn + QyMax) / 2!
'
    ' Verifico se e' richiesto il
    ' disegno della griglia:
    If Not bGriglia Then GoTo Fine
'
'-------------------------------------------------------------------------------------
'   Disegna assi, griglie e scrive i valori di scala.
'
    Foglio.FontSize = 8
    Foglio.DrawWidth = 1
    Foglio.DrawMode = vbCopyPen
    Foglio.ForeColor = RifCol
'
    ' Traccio la griglia verticale e scrivo
    ' i valori dell' asse X:
    Foglio.DrawStyle = vbDash
    For XI = X0 To xn + 0.1 * rrx Step rrx
        Foglio.Line (XI, Y0)-(XI, yn), RifCol
        Txt$ = Format$(XI, FormatVX$)
        ' Verifico che il formato scelto non
        ' induca ad errori di rappresentazione:
        If Abs(XI - Val(Txt$)) < rrx / 10 Then
            Foglio.CurrentX = XI - Foglio.TextWidth(Txt$) / 2!
            Foglio.CurrentY = Y0 + Po4_Y / 2!
            Foglio.Print Txt$;
        End If
    Next XI
    ' Scrivo l' etichetta dell' asse X:
    If Len(UnitaX$) > 0 Then
        ' Etichetta tutta a destra:
        'Foglio.CurrentX = QxMax - Foglio.TextWidth(UnitaX$ & " ")
        ' Etichetta in centro tra l' ultimo valore ed il bordo a destra:
        Foglio.CurrentX = (Foglio.CurrentX + QxMax - Foglio.TextWidth(UnitaX$)) / 2!
        Foglio.CurrentY = Y0 + Po4_Y / 2!
        Foglio.Print UnitaX$;
    End If
    ' Traccio l' asse Y:
    If (X0 <= 0!) And (0! <= xn) Then
        Foglio.DrawStyle = vbSolid
        Foglio.Line (0!, Y0)-(0!, EstAy), RifCol
        Foglio.Line (0!, EstAy)-(-Po4_X / 2!, Po4_Y + EstAy), RifCol
        Foglio.Line (0!, EstAy)-(Po4_X / 2!, Po4_Y + EstAy), RifCol
    End If
'
    ' Traccio la griglia orizzontale e scrivo
    ' i valori dell' asse Y:
    Foglio.DrawStyle = vbDash
    For YI = Y0 To yn + 0.1 * rry Step rry
        Foglio.Line (X0, YI)-(xn, YI), RifCol
        Txt$ = Format$(YI, FormatVY$)
        ' Verifico che il formato scelto non
        ' induca ad errori di rappresentazione:
        'If Abs(YI - Val(Txt$)) < rry / 10 Then
            Foglio.CurrentX = QxMin
            Foglio.CurrentY = YI - Foglio.TextHeight(Txt$) / 2!
            Foglio.Print Txt$;
        'End If
     Next YI
    ' Scrivo l' etichetta dell' asse Y:
    If Len(UnitaY$) > 0 Then
        Foglio.CurrentX = QxMin
        Foglio.CurrentY = QyMax
        Foglio.Print UnitaY$;
    End If
    ' Traccio l' asse X:
    If (Y0 <= 0!) And (0! <= yn) Then
        Foglio.DrawStyle = vbSolid
        Foglio.Line (X0, 0!)-(EstAx, 0!), RifCol
        Foglio.Line (EstAx, 0!)-(EstAx - Po4_X, -Po4_Y / 2!), RifCol
        Foglio.Line (EstAx, 0!)-(EstAx - Po4_X, Po4_Y / 2!), RifCol
    End If
'
'-------------------------------------------------------------------------------------
'   Scrive il titolo del grafico:
'
    Dim TitL!, TitT!, TitW!, TitH!
'
    If Len(Titolo$) > 0 Then
        Foglio.FontSize = 12
        Foglio.FontBold = True
        Foglio.ForeColor = vbRed
'
        TitW = Foglio.TextWidth(Titolo$)
        TitH = Foglio.TextHeight(Titolo$)
        ' Verifico che il titolo stia tutto nel Foglio:
        If TitW <= Foglio.ScaleWidth Then
            TitL = (QxMin + QxMax - TitW) / 2!
        ' e se no' lo taglio:
        Else
            TitL = Foglio.ScaleLeft
            Txt$ = " . . . ."
            Titolo$ = Left$(Titolo$, Int(Len(Titolo$) * _
            (Foglio.ScaleWidth - Foglio.TextWidth(Txt$)) / TitW)) & Txt$
        End If
        TitT = QyMax
        ' Cancello l' area su cui andra' scritto il titolo:
        'Foglio.Line (TitL, TitT)-(TitL + TitW, TitT + TitH), Foglio.BackColor, BF
        Foglio.CurrentX = TitL
        Foglio.CurrentY = TitT
        Foglio.Print Titolo$
    End If
'
Fine:
    Foglio.DrawStyle = vbSolid
    Foglio.AutoRedraw = AutoRed
'
'
Quadro_ERR:
    Quadro = (Err = 0)
    If Err <> 0 Then
        MsgBox Err.Description, vbCritical, " Quadro/" & Err.Source
    End If
    tEsec = Timer - tEsec
'
'
'
End Function
Public Function Ceil(ByVal X As Double) As Double
'
'   Funzione di arrotondamento, per numeri reali,
'   all' intero uguale o immediatamente superiore:
'
    If X = Int(X) Then
        Ceil = X
    Else
        Ceil = Int(X) + 1#
    End If
'
'
'
End Function
Public Function MAX0(ParamArray Vd() As Variant) As Long
'
'   Implementa la funzione MAX0(K1, K2, ...KN) del FORTRAN:
'
    Dim J&, J1&, J2&, vDMax As Variant
'
    J1 = LBound(Vd)
    J2 = UBound(Vd)
    vDMax = Vd(J1)
    For J = J1 + 1 To J2
        If vDMax < Vd(J) Then vDMax = Vd(J)
    Next J
'
    MAX0 = CLng(vDMax)
'
'
'
End Function
Public Function MIN0(ParamArray Vd() As Variant) As Long
'
'   Implementa la funzione MIN0(K1, K2, ...KN) del FORTRAN:
'
    Dim J&, J1&, J2&, vDMin As Variant
'
    J1 = LBound(Vd)
    J2 = UBound(Vd)
    vDMin = Vd(J1)
    For J = J1 + 1 To J2
        If vDMin > Vd(J) Then vDMin = Vd(J)
    Next J
'
    MIN0 = CLng(vDMin)
'
'
'
End Function
Public Function BreakDown(ByVal Full$, Optional ByRef PName$, _
    Optional ByRef FName$, Optional ByRef Ext$) As Boolean
'
'   Scompone un nome di File completo di Path nelle sue parti:
'    Full$  = Nome completo del File.
'    PName$ = Path del File (con \ finale).
'    FName$ = Nome del File con Estensione.
'    Ext$   = .Estensione del File.
'
'   Se il File non esiste scompone il nome e ritorna False.
'
    Dim Sloc&, Dot&
'
    BreakDown = FileExists(Full$)
'
    If InStr(Full$, "\") Then
        FName$ = Full$
        PName$ = ""
        Sloc = InStr(FName$, "\")
        Do While Sloc <> 0
            PName$ = PName$ & Left$(FName$, Sloc)
            FName$ = Mid$(FName$, Sloc + 1)
            Sloc = InStr(FName$, "\")
        Loop
    Else
        PName$ = ""
        FName$ = Full$
    End If
'
    Dot = InStr(Full$, ".")
    If Dot <> 0 Then
        Ext$ = Mid$(Full$, Dot)
    Else
        Ext$ = ""
    End If
'
'
'
End Function
Private Function FileExists(ByVal FileN$) As Boolean
'
'   Verifica l' esistenza del file FileN$:
'
    Dim res&
'
    On Error Resume Next
'
    res = FileLen(FileN$)
    FileExists = (Err = 0)
    Err.Clear
'
'
'
End Function
Public Function Atan2(ByVal Y#, ByVal X#) As Double
'
'   Ritorna il Valore dell' ArcoTangente di y/x su 4 Quadranti.
'   E':    0 <= Atan2 < 2 * PI.
'
    Select Case X
    Case Is > 0#
        If Y >= 0# Then
            Atan2 = Atn(Y / X)
        Else
            Atan2 = Atn(Y / X) + PI2
        End If
'
    Case Is < 0#
        Atan2 = Atn(Y / X) + PI
'
    Case Is = 0#
        If Y >= 0# Then
            Atan2 = PI / 2#
        Else
            Atan2 = 3# * PI / 2#
        End If
    End Select
'
'
'
End Function

Public Function DMINVAL(dVet#()) As Double
'
'   Ritorna il valore minimo contenuto nel vettore dVet().
'   Implementa l' equivalente funzione del FORTRAN.
'
    Dim J&, J1&, J2&, dDMin#
'
    J1 = LBound(dVet)
    J2 = UBound(dVet)
    dDMin = dVet(J1)
    For J = J1 + 1 To J2
        If dDMin > dVet(J) Then dDMin = dVet(J)
    Next J
'
    DMINVAL = dDMin
'
'
'
End Function
Public Function DMAXVAL(dVet#()) As Double
'
'   Ritorna il valore massimo contenuto nel vettore dVet().
'   Implementa l' equivalente funzione del FORTRAN.
'
    Dim J&, J1&, J2&, dDMax#
'
    J1 = LBound(dVet)
    J2 = UBound(dVet)
    dDMax = dVet(J1)
    For J = J1 + 1 To J2
        If dDMax < dVet(J) Then dDMax = dVet(J)
    Next J
'
    DMAXVAL = dDMax
'
'
'
End Function
